#include <stdio.h>
main(){
	int br=0;
	long n,m,i,j,b,a;
	scanf("%ld %ld",&n,&m);
	long vage[n][2],pitanja[m][3];
	for(i=0;i<n;i++)	scanf("%ld %ld",&vage[i][0],&vage[i][1]);
	for(i=0;i<m;i++)	scanf("%ld %ld %ld",&pitanja[i][0],&pitanja[i][1],&pitanja[i][2]);
	
	for(i=0;i<m;i++){
		for(j=pitanja[i][0]-1;j<pitanja[i][1]-1;j++){
			a=pitanja[i][2]-vage[j][0];
			//printf("\n%d-%d\n",pitanja[i][2],vage[j][0]);
			b=vage[j][1]-pitanja[i][2];
			//printf("\n%d-%d\n",vage[j][1],pitanja[i][2]);
			//printf("a:%d\nb:%d\n",a,b);
			if(a>=0 && b>=0)	b++;
		}
		if(b>0)	printf("1");
		else	printf("0");
	}
	
		
	/*for(i=0;i<n;i++)	printf("\n%ld %ld",vage[i][0],vage[i][1]);
	printf("\n\n\n");
	for(i=0;i<m;i++)	printf("\n%ld %ld %ld",pitanja[i][0],pitanja[i][1],pitanja[i][2]);
	printf("\n\n%ld",b);	*/
}